CAD C#二次开发 圆和圆弧转Polyline线

               //假设现有实体ent
                Entity ent = item as Entity;
                //如果实体为圆弧
                if (ent is Arc) 
                {
                    Arc arc = ent as Arc;
                    double R = arc.Radius;
                    Point3d startPoint = arc.StartPoint;
                    Point3d endPoint = arc.EndPoint;
                    Point2d p1, p2;
                    p1 = new Point2d(startPoint.X, startPoint.Y);
                    p2 = new Point2d(endPoint.X, endPoint.Y);
                    Double L = p1.GetDistanceTo(p2);
                    double H = R - Math.Sqrt(R * R - L * L / 4);

                    Polyline poly = new Polyline();
                    poly.AddVertexAt(0, p1, 2 * H / L, 0, 0);
                    poly.AddVertexAt(1, p2, 0, 0, 0);
                    poly.Color = reg.Color;
                    poly.LineWeight = reg.LineWeight;
                    poly.LinetypeId = reg.LinetypeId;
                    btr.AppendEntity(poly);
                    trans.AddNewlyCreatedDBObject(poly, true);
                }
                //如果实体为圆
                else if (ent is Circle) 
                {
                    Circle cir = ent as Circle;
                    double r = cir.Radius;
                    Point3d cc = cir.Center;
                    Point2d p1 = new Point2d(cc.X + r, cc.Y);
                    Point2d p2 = new Point2d(cc.X - r, cc.Y);
                    Polyline poly = new Polyline();
                    poly.AddVertexAt(0, p1, 1, 0, 0);
                    poly.AddVertexAt(1, p2, 1, 0, 0);
                    poly.AddVertexAt(2, p1, 1, 0, 0);
                    poly.Color = reg.Color;
                    poly.LineWeight = reg.LineWeight;
                    poly.LinetypeId = reg.LinetypeId;
                    btr.AppendEntity(poly);
                    trans.AddNewlyCreatedDBObject(poly, true);
                }

  • 4
    点赞
  • 14
    收藏
    觉得还不错? 一键收藏
  • 3
    评论
以下是C#二次开发CAD填充代码的示例: ```csharp using Autodesk.AutoCAD.ApplicationServices; using Autodesk.AutoCAD.DatabaseServices; using Autodesk.AutoCAD.EditorInput; using Autodesk.AutoCAD.Runtime; using Autodesk.AutoCAD.Geometry; using System; namespace FillPolyline { public class Commands { [CommandMethod("FillPolyline")] public void FillPolyline() { Document doc = Application.DocumentManager.MdiActiveDocument; Database db = doc.Database; Editor ed = doc.Editor; // 选择多段线 PromptEntityOptions peo = new PromptEntityOptions("\n选择多段线: "); peo.SetRejectMessage("\n必须选择一个多段线!"); peo.AddAllowedClass(typeof(Polyline), true); PromptEntityResult per = ed.GetEntity(peo); if (per.Status != PromptStatus.OK) return; using (Transaction tr = db.TransactionManager.StartTransaction()) { Polyline pline = tr.GetObject(per.ObjectId, OpenMode.ForWrite) as Polyline; if (pline == null) return; // 创建填充对象 Hatch hatch = new Hatch(); hatch.SetDatabaseDefaults(); hatch.Layer = pline.Layer; hatch.ColorIndex = pline.ColorIndex; hatch.PatternScale = 1.0; // 设置填充类型 hatch.PatternType = HatchPatternType.PreDefined; hatch.PatternName = "SOLID"; // 获取多段线边界 Point3dCollection pts = new Point3dCollection(); for (int i = 0; i < pline.NumberOfVertices; i++) { pts.Add(pline.GetPoint3dAt(i)); } // 添加填充边界 hatch.AppendLoop(HatchLoopTypes.Outermost, pts); // 将填充对象添加到模型空间 BlockTableRecord btr = tr.GetObject(db.CurrentSpaceId, OpenMode.ForWrite) as BlockTableRecord; btr.AppendEntity(hatch); tr.AddNewlyCreatedDBObject(hatch, true); // 关联填充对象和多段线 hatch.Associative = true; hatch.AppendLoop(HatchLoopTypes.Default, new ObjectIdCollection() { pline.ObjectId }); hatch.EvaluateHatch(true); tr.Commit(); } } } } ``` 上述代码中,通过 `PromptEntityOptions` 和 `ed.GetEntity` 方法选择了一个多段线,然后创建了一个填充对象并将其添加到模型空间。最后,通过将填充对象与多段线关联,实现了填充功能。

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论 3
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值